/*jslint devel: true, node: true, bitwise: false, debug: false, eqeq: false,
evil: false, forin: false, newcap: false, nomen: false, plusplus: false,
regexp: false, sub: false, vars: false, undef: false, unused: false,
white: false, quotmark: single, indent: 2, maxlen: 80 */

/*global $, Alloy, alert, Ti, OS_ANDROID, OS_IOS, _, Backbone*/

'use strict';

var OS_ANDROID = (Ti.Platform.osname=='android') ? true : false;
var OS_IOS = (Ti.Platform.osname=='iphone') ? true : false;

var month = [];
month[0] = 'Jan.';
month[1] = 'Feb.';
month[2] = 'Mar.';
month[3] = 'Apr.';
month[4] = 'May';
month[5] = 'Jun.';
month[6] = 'Jul.';
month[7] = 'Aug.';
month[8] = 'Sep.';
month[9] = 'Oct.';
month[10] = 'Nov.';
month[11] = 'Dec.';

var year = [];
year[0] = 'Year One';
year[1] = 'Year Two';
year[2] = 'Year Three';
year[3] = 'Year Four';
year[4] = 'Year Five';
year[5] = 'Year Six';
year[6] = 'Year Seven';
year[7] = 'Year Eight';
year[8] = 'Year Nine';
year[9] = 'Year Ten';
year[10] = 'Year Eleven';
year[11] = 'Year Twelve';
year[12] = 'Year Thirteen';
year[13] = 'Year Fourteen';
year[14] = 'Year Fifteen';
year[15] = 'Year Sixteen';
year[16] = 'Year Seventeen';
year[17] = 'Year Eighteen';
year[18] = 'Year Nineteen';
year[19] = 'Year Twenty';
year[20] = 'Year Twenty-One';
year[21] = 'Year Twenty-Two';
year[22] = 'Year Twenty-Three';
year[23] = 'Year Twenty-Four';
year[24] = 'Year Twenty-Five';
year[25] = 'Year Twenty-Six';
year[26] = 'Year Twenty-Seven';
year[27] = 'Year Twenty-Eight';
year[28] = 'Year Twenty-Nine';
year[29] = 'Year Thirty';

exports.monthName = function (monthValue) {
  return month[monthValue];
};

exports.monthNumber = function (monthName) {
  return month.indexOf(monthName);
};

exports.yearName = function (monthValue) {
  return year[monthValue];
};

exports.yearName = function(yearNumber) {
  return year[yearNumber];
};

exports.addCommas = function (nString)
{
  var num, nInt1, nInt2, regX;

  //Ti.API.info('In Add Commas ' + nString);

  nString = nString.toString();
  num = nString.split('.');
  nInt1 = num[0];
  nInt2 = num.length > 1 ? '.' + num[1] : '';
  regX = /(\d+)(\d{3})/;
  while (regX.test(nInt1))
  {
    nInt1 = nInt1.replace(regX, '$1' + ',' + '$2');
  }

  return nInt1 + nInt2;
};

exports.dollars = function (nString) {
  nString = (nString).toString();
  if (nString.indexOf('$') === -1) {
    return '$' + nString;
  } else {
    return nString;
  }
};

exports.rounded = function (input) {
  return (Math.round(input));
};

exports.percentage = function (nString) {
  nString = nString.toString();
  if (nString.indexOf('%') === -1) {
    return nString + '%';
  } else {
    return nString;
  }
};

exports.years = function (nString) {
  nString = nString.toString();
  if (nString.indexOf('YRS') === -1) {
    return nString +  'YRS';
  } else {
    return nString;
  }
};

exports.slashyear = function (nString) {
  nString = nString.toString();
  if (nString.indexOf('/YR') === -1) {
    return nString + '/YR';
  } else {
    return nString;
  }
};

exports.nullToZero = function (input) {
  if (typeof input === null || undefined) {
    return 0;
  }
};

exports.removeFormat = function (nString)
{
  nString = nString.toString();
  return parseFloat(nString.replace(/[^\d\.]/g, ''));
};

exports.smallNumberFormat = function (val) {
  var num, postfix;

  // Prints $10M, to infinity.

  if (! _.isFinite(val)) {
    return;
  }

  if (val >= 10000000) {
    return Math.ceil(val / 1000000) + 'M';

  // Prints $1.0M, through $9.9M.

  } else if (val > 999000) {
    return (Math.ceil(val / 100000) / 10) + 'M';

  // Prints $1K, through $999K.

  } else if (val >= 1000) {
    return Math.ceil(val / 1000) + 'K';

  // Prints $0, through $999.

  } else {
    return String(val);
  }
};

exports.nativeToDips = function (nat) {
  if (OS_IOS) {
    return nat;
  }
  if (OS_ANDROID) {
    return nat / Ti.Platform.displayCaps.logicalDensityFactor;
  }
};
